//
// Created by Marco Bertini on 16/03/16.
//

#ifndef DANDD_160316_2_GAMECHARACTER_H
#define DANDD_160316_2_GAMECHARACTER_H

#include "Weapon.h"

class GameCharacter {
public:
    GameCharacter();
    GameCharacter(int x, int y, int hp=10, Weapon* w=nullptr);
    GameCharacter(GameCharacter& orig);  // TODO implement
    ~GameCharacter();

    GameCharacter& operator=(GameCharacter& right);

    void move(int x, int y);
    void fight(GameCharacter& enemy);

    int getPosX() const {
        return posX;
    }

    void setPosX(int posX) {
        GameCharacter::posX = posX;
    }

    int getPosY() const {
        return posY;
    }

    void setPosY(int posY) {
        GameCharacter::posY = posY;
    }

    int getHitPoints() const {
        return hitPoints;
    }

    void setHitPoints(int hitPoints) {
        GameCharacter::hitPoints = hitPoints;
    }

    Weapon* getWeapon() const {
        return weapon;
    }

    void setWeapon(Weapon* weapon) {
        GameCharacter::weapon = weapon;
    }

private:
    int posX;
    int posY;
    int hitPoints;
    Weapon* weapon;
};


#endif //DANDD_160316_2_GAMECHARACTER_H
